diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index 7f5d3b1417a..00d3351dd86 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -75,7 +75,6 @@
 #include "pgstat.h"
 #include "port/atomics.h"
 #include "postmaster/bgwriter.h"
-#include "postmaster/datachecksum_state.h"
 #include "postmaster/startup.h"
 #include "postmaster/walsummarizer.h"
 #include "postmaster/walwriter.h"
@@ -93,7 +92,6 @@
 #include "storage/predicate.h"
 #include "storage/proc.h"
 #include "storage/procarray.h"
-#include "storage/procsignal.h"
 #include "storage/reinit.h"
 #include "storage/spin.h"
 #include "storage/subsystems.h"
@@ -556,18 +554,7 @@ typedef struct XLogCtlData
 	 */
 	XLogRecPtr	lastFpwDisableRecPtr;
 
-	/* last data_checksum_version we've seen */
-	uint32		data_checksum_version;
-
 	slock_t		info_lck;		/* locks shared variables shown above */
-
-	/*
-	 * lastChecksumChangeRecPtr points to the end of the last XLOG2_CHECKSUMS
-	 * record inserted or replayed, i.e. the last change of
-	 * data_checksum_version.  InvalidXLogRecPtr if the state hasn't changed
-	 * since the server started.
-	 */
-	pg_atomic_uint64 lastChecksumChangeRecPtr;
 } XLogCtlData;
 
 /*
@@ -675,21 +662,6 @@ static XLogRecPtr LocalMinRecoveryPoint;
 static TimeLineID LocalMinRecoveryPointTLI;
 static bool updateMinRecoveryPoint = true;
 
-/*
- * Local state for ControlFile data_checksum_version.  After initialization
- * this is only updated when absorbing a procsignal barrier during interrupt
- * processing.  The reason for keeping a copy in backend-private memory is to
- * avoid locking for interrogating the data checksum state.  Possible values
- * are the data checksum versions defined in storage/checksum.h.
- */
-static ChecksumStateType LocalDataChecksumState = 0;
-
-/*
- * Variable backing the GUC, keep it in sync with LocalDataChecksumState.
- * See SetLocalDataChecksumState().
- */
-int			data_checksums = 0;
-
 /* For WALInsertLockAcquire/Release functions */
 static int	MyLockNo = 0;
 static bool holdingAllLocks = false;
@@ -757,8 +729,6 @@ static void WALInsertLockAcquireExclusive(void);
 static void WALInsertLockRelease(void);
 static void WALInsertLockUpdateInsertingAt(XLogRecPtr insertingAt);
 
-static void XLogChecksums(uint32 new_type);
-
 /*
  * Insert an XLOG record represented by an already-constructed chain of data
  * chunks.  This is a low-level routine; to construct the WAL record header
@@ -4292,13 +4262,6 @@ InitControlFile(uint64 sysidentifier, uint32 data_checksum_version)
 	ControlFile->wal_log_hints = wal_log_hints;
 	ControlFile->track_commit_timestamp = track_commit_timestamp;
 	ControlFile->data_checksum_version = data_checksum_version;
-	ControlFile->data_checksum_version_init = data_checksum_version;
-
-	/*
-	 * Set the data_checksum_version value into XLogCtl, which is where all
-	 * processes get the current value from.
-	 */
-	XLogCtl->data_checksum_version = data_checksum_version;
 }
 
 static void
@@ -4633,6 +4596,10 @@ ReadControlFile(void)
 		(SizeOfXLogLongPHD - SizeOfXLogShortPHD);
 
 	CalculateCheckpointSegments();
+
+	/* Make the initdb settings visible as GUC variables, too */
+	SetConfigOption("data_checksums", DataChecksumsEnabled() ? "yes" : "no",
+					PGC_INTERNAL, PGC_S_DYNAMIC_DEFAULT);
 }
 
 /*
@@ -4666,347 +4633,13 @@ GetMockAuthenticationNonce(void)
 }
 
 /*
- * DataChecksumsNeedWrite
- *		Returns whether data checksums must be written or not
- *
- * Returns true if data checksums are enabled, or are in the process of being
- * enabled. During "inprogress-on" and "inprogress-off" states checksums must
- * be written even though they are not verified (see datachecksum_state.c for
- * a longer discussion).
- *
- * This function is intended for callsites which are about to write a data page
- * to storage, and need to know whether to re-calculate the checksum for the
- * page header. Calling this function must be performed as close to the write
- * operation as possible to keep the critical section short.
+ * Are checksums enabled for data pages?
  */
 bool
-DataChecksumsNeedWrite(void)
-{
-	return (LocalDataChecksumState == PG_DATA_CHECKSUM_VERSION ||
-			LocalDataChecksumState == PG_DATA_CHECKSUM_INPROGRESS_ON ||
-			LocalDataChecksumState == PG_DATA_CHECKSUM_INPROGRESS_OFF);
-}
-
-
-bool
-DataChecksumsOff(void)
-{
-	bool		ret;
-
-	SpinLockAcquire(&XLogCtl->info_lck);
-	ret = (XLogCtl->data_checksum_version == PG_DATA_CHECKSUM_OFF);
-	SpinLockRelease(&XLogCtl->info_lck);
-
-	return ret;
-}
-
-bool
-DataChecksumsOn(void)
-{
-	bool		ret;
-
-	SpinLockAcquire(&XLogCtl->info_lck);
-	ret = (XLogCtl->data_checksum_version == PG_DATA_CHECKSUM_VERSION);
-	SpinLockRelease(&XLogCtl->info_lck);
-
-	return ret;
-}
-
-bool
-DataChecksumsInProgressOn(void)
-{
-	bool		ret;
-
-	SpinLockAcquire(&XLogCtl->info_lck);
-	ret = (XLogCtl->data_checksum_version == PG_DATA_CHECKSUM_INPROGRESS_ON);
-	SpinLockRelease(&XLogCtl->info_lck);
-
-	return ret;
-}
-
-/*
- * DataChecksumsNeedVerify
- *		Returns whether data checksums must be verified or not
- *
- * Data checksums are only verified if they are fully enabled in the cluster.
- * During the "inprogress-on" and "inprogress-off" states they are only
- * updated, not verified (see datachecksum_state.c for a longer discussion).
- *
- * This function is intended for callsites which have read data and are about
- * to perform checksum validation based on the result of this.  Calling this
- * function must be performed as close to the validation call as possible to
- * keep the critical section short. This is in order to protect against time of
- * check/time of use situations around data checksum validation.
- */
-bool
-DataChecksumsNeedVerify(void)
-{
-	return (LocalDataChecksumState == PG_DATA_CHECKSUM_VERSION);
-}
-
-/*
- * GetLastChecksumChangeRecPtr
- *		Returns the location of the last data checksum state change
- *
- * Offline state changes by pg_checksums leave no trace here; callers must
- * also inspect the current state.
- *
- * No barrier semantics are needed: pages reach disk under a new checksum
- * state only after their writer absorbed the procsignal barrier for the
- * change, which is emitted after the new location became visible.
- */
-XLogRecPtr
-GetLastChecksumChangeRecPtr(void)
-{
-	return pg_atomic_read_u64(&XLogCtl->lastChecksumChangeRecPtr);
-}
-
-/*
- * SetDataChecksumsOnInProgress
- *		Sets the data checksum state to "inprogress-on" to enable checksums
- *
- * To start the process of enabling data checksums in a running cluster the
- * data_checksum_version state must be changed to "inprogress-on". See
- * SetDataChecksumsOn below for a description on how this state change works.
- * This function blocks until all backends in the cluster have acknowledged the
- * state transition.
- */
-void
-SetDataChecksumsOnInProgress(void)
-{
-	uint64		barrier;
-
-	/*
-	 * The state transition is performed in a critical section with
-	 * checkpoints held off to provide crash safety.
-	 */
-	START_CRIT_SECTION();
-	MyProc->delayChkptFlags |= DELAY_CHKPT_START;
-
-	XLogChecksums(PG_DATA_CHECKSUM_INPROGRESS_ON);
-
-	SpinLockAcquire(&XLogCtl->info_lck);
-	XLogCtl->data_checksum_version = PG_DATA_CHECKSUM_INPROGRESS_ON;
-	SpinLockRelease(&XLogCtl->info_lck);
-
-	LWLockAcquire(ControlFileLock, LW_EXCLUSIVE);
-	ControlFile->data_checksum_version = PG_DATA_CHECKSUM_INPROGRESS_ON;
-	UpdateControlFile();
-	LWLockRelease(ControlFileLock);
-
-	barrier = EmitProcSignalBarrier(PROCSIGNAL_BARRIER_CHECKSUM_INPROGRESS_ON);
-
-	MyProc->delayChkptFlags &= ~DELAY_CHKPT_START;
-	END_CRIT_SECTION();
-
-	WaitForProcSignalBarrier(barrier);
-}
-
-/*
- * SetDataChecksumsOn
- *		Set data checksums state to 'on' cluster-wide
- *
- * Enabling data checksums is performed using two barriers, the first one to
- * set the state to "inprogress-on" (done by SetDataChecksumsOnInProgress())
- * and the second one to set the state to "on" (done here). Below is a short
- * description of the processing, a more detailed write-up can be found in
- * datachecksum_state.c.
- *
- * To start the process of enabling data checksums in a running cluster the
- * data_checksum_version state must be changed to "inprogress-on".  This state
- * requires data checksums to be written but not verified. This ensures that
- * all data pages can be checksummed without the risk of false negatives in
- * validation during the process.  When all existing pages are guaranteed to
- * have checksums, and all new pages will be initiated with checksums, the
- * state can be changed to "on". Once the state is "on" checksums will be both
- * written and verified.
- *
- * This function blocks until all backends in the cluster have acknowledged the
- * state transition.
- */
-void
-SetDataChecksumsOn(void)
+DataChecksumsEnabled(void)
 {
-	uint64		barrier;
-
-	SpinLockAcquire(&XLogCtl->info_lck);
-
-	/*
-	 * The only allowed state transition to "on" is from "inprogress-on" since
-	 * that state ensures that all pages will have data checksums written. Any
-	 * other attempted state transition is likely due to a programmer error.
-	 */
-	if (XLogCtl->data_checksum_version != PG_DATA_CHECKSUM_INPROGRESS_ON)
-	{
-		SpinLockRelease(&XLogCtl->info_lck);
-		elog(WARNING,
-			 "cannot set data checksums to \"on\", current state is not \"inprogress-on\", disabling");
-		SetDataChecksumsOff();
-		return;
-	}
-
-	SpinLockRelease(&XLogCtl->info_lck);
-
-	INJECTION_POINT("datachecksums-enable-checksums-delay", NULL);
-	START_CRIT_SECTION();
-	MyProc->delayChkptFlags |= DELAY_CHKPT_START;
-
-	XLogChecksums(PG_DATA_CHECKSUM_VERSION);
-
-	SpinLockAcquire(&XLogCtl->info_lck);
-	XLogCtl->data_checksum_version = PG_DATA_CHECKSUM_VERSION;
-	SpinLockRelease(&XLogCtl->info_lck);
-
-	/*
-	 * Update the controlfile before waiting since if we have an immediate
-	 * shutdown while waiting we want to come back up with checksums enabled.
-	 */
-	LWLockAcquire(ControlFileLock, LW_EXCLUSIVE);
-	ControlFile->data_checksum_version = PG_DATA_CHECKSUM_VERSION;
-	UpdateControlFile();
-	LWLockRelease(ControlFileLock);
-
-	barrier = EmitProcSignalBarrier(PROCSIGNAL_BARRIER_CHECKSUM_ON);
-
-	MyProc->delayChkptFlags &= ~DELAY_CHKPT_START;
-	END_CRIT_SECTION();
-
-	INJECTION_POINT("datachecksums-on-before-checkpoint", NULL);
-
-	RequestCheckpoint(CHECKPOINT_FORCE | CHECKPOINT_WAIT | CHECKPOINT_FAST);
-	WaitForProcSignalBarrier(barrier);
-}
-
-/*
- * SetDataChecksumsOff
- *		Disables data checksums cluster-wide
- *
- * Disabling data checksums must be performed with two sets of barriers, each
- * carrying a different state. The state is first set to "inprogress-off"
- * during which checksums are still written but not verified. This ensures that
- * backends which have yet to observe the state change from "on" won't get
- * validation errors on concurrently modified pages. Once all backends have
- * changed to "inprogress-off", the barrier for moving to "off" can be emitted.
- * This function blocks until all backends in the cluster have acknowledged the
- * state transition.
- */
-void
-SetDataChecksumsOff(void)
-{
-	uint64		barrier;
-
-	SpinLockAcquire(&XLogCtl->info_lck);
-
-	/* If data checksums are already disabled there is nothing to do */
-	if (XLogCtl->data_checksum_version == PG_DATA_CHECKSUM_OFF)
-	{
-		SpinLockRelease(&XLogCtl->info_lck);
-		return;
-	}
-
-	/*
-	 * If data checksums are currently enabled, or in the process of being
-	 * enabled, we first transition to the "inprogress-off" state during which
-	 * backends continue to write checksums without verifying them. When all
-	 * backends are in "inprogress-off" the next transition to "off" can be
-	 * performed, after which all data checksum processing is disabled.
-	 */
-	if (XLogCtl->data_checksum_version == PG_DATA_CHECKSUM_VERSION ||
-		XLogCtl->data_checksum_version == PG_DATA_CHECKSUM_INPROGRESS_ON)
-	{
-		SpinLockRelease(&XLogCtl->info_lck);
-
-		START_CRIT_SECTION();
-		MyProc->delayChkptFlags |= DELAY_CHKPT_START;
-
-		XLogChecksums(PG_DATA_CHECKSUM_INPROGRESS_OFF);
-
-		SpinLockAcquire(&XLogCtl->info_lck);
-		XLogCtl->data_checksum_version = PG_DATA_CHECKSUM_INPROGRESS_OFF;
-		SpinLockRelease(&XLogCtl->info_lck);
-
-		LWLockAcquire(ControlFileLock, LW_EXCLUSIVE);
-		ControlFile->data_checksum_version = PG_DATA_CHECKSUM_INPROGRESS_OFF;
-		UpdateControlFile();
-		LWLockRelease(ControlFileLock);
-
-		barrier = EmitProcSignalBarrier(PROCSIGNAL_BARRIER_CHECKSUM_INPROGRESS_OFF);
-
-		MyProc->delayChkptFlags &= ~DELAY_CHKPT_START;
-		END_CRIT_SECTION();
-
-		RequestCheckpoint(CHECKPOINT_FORCE | CHECKPOINT_WAIT | CHECKPOINT_FAST);
-		WaitForProcSignalBarrier(barrier);
-
-		/*
-		 * At this point we know that no backends are verifying data checksums
-		 * during reading. Next, we can safely move to state "off" to also
-		 * stop writing checksums.
-		 */
-	}
-	else
-	{
-		/*
-		 * Ending up here implies that the checksums state is "inprogress-off"
-		 * and we can transition directly to "off" from there.
-		 */
-		SpinLockRelease(&XLogCtl->info_lck);
-	}
-
-	START_CRIT_SECTION();
-	/* Ensure that we don't incur a checkpoint during disabling checksums */
-	MyProc->delayChkptFlags |= DELAY_CHKPT_START;
-
-	XLogChecksums(PG_DATA_CHECKSUM_OFF);
-
-	SpinLockAcquire(&XLogCtl->info_lck);
-	XLogCtl->data_checksum_version = PG_DATA_CHECKSUM_OFF;
-	SpinLockRelease(&XLogCtl->info_lck);
-
-	LWLockAcquire(ControlFileLock, LW_EXCLUSIVE);
-	ControlFile->data_checksum_version = PG_DATA_CHECKSUM_OFF;
-	UpdateControlFile();
-	LWLockRelease(ControlFileLock);
-
-	barrier = EmitProcSignalBarrier(PROCSIGNAL_BARRIER_CHECKSUM_OFF);
-
-	MyProc->delayChkptFlags &= ~DELAY_CHKPT_START;
-	END_CRIT_SECTION();
-
-	RequestCheckpoint(CHECKPOINT_FORCE | CHECKPOINT_WAIT | CHECKPOINT_FAST);
-	WaitForProcSignalBarrier(barrier);
-}
-
-/*
- * InitLocalDataChecksumState
- *
- * Set up backend local caches of controldata variables which may change at
- * any point during runtime and thus require special cased locking. So far
- * this only applies to data_checksum_version, but it's intended to be general
- * purpose enough to handle future cases.
- */
-void
-InitLocalDataChecksumState(void)
-{
-	Assert(InterruptHoldoffCount > 0);
-	SpinLockAcquire(&XLogCtl->info_lck);
-	SetLocalDataChecksumState(XLogCtl->data_checksum_version);
-	SpinLockRelease(&XLogCtl->info_lck);
-}
-
-void
-SetLocalDataChecksumState(uint32 data_checksum_version)
-{
-	LocalDataChecksumState = data_checksum_version;
-
-	data_checksums = data_checksum_version;
-}
-
-/* guc hook */
-const char *
-show_data_checksums(void)
-{
-	return get_checksum_state_string(LocalDataChecksumState);
+	Assert(ControlFile != NULL);
+	return (ControlFile->data_checksum_version > 0);
 }
 
 /*
@@ -5301,7 +4934,6 @@ LocalProcessControlFile(bool reset)
 	LocalControlFile = palloc_object(ControlFileData);
 	ControlFile = LocalControlFile;
 	ReadControlFile();
-	SetLocalDataChecksumState(ControlFile->data_checksum_version);
 }
 
 /*
@@ -5453,17 +5085,12 @@ XLOGShmemInit(void *arg)
 	XLogCtl->InstallXLogFileSegmentActive = false;
 	XLogCtl->WalWriterSleeping = false;
 
-	/* Use the checksum info from control file */
-	XLogCtl->data_checksum_version = ControlFile->data_checksum_version;
-	SetLocalDataChecksumState(XLogCtl->data_checksum_version);
-
 	SpinLockInit(&XLogCtl->Insert.insertpos_lck);
 	SpinLockInit(&XLogCtl->info_lck);
 	pg_atomic_init_u64(&XLogCtl->logInsertResult, InvalidXLogRecPtr);
 	pg_atomic_init_u64(&XLogCtl->logWriteResult, InvalidXLogRecPtr);
 	pg_atomic_init_u64(&XLogCtl->logFlushResult, InvalidXLogRecPtr);
 	pg_atomic_init_u64(&XLogCtl->unloggedLSN, InvalidXLogRecPtr);
-	pg_atomic_init_u64(&XLogCtl->lastChecksumChangeRecPtr, InvalidXLogRecPtr);
 }
 
 /*
@@ -5541,7 +5168,6 @@ BootStrapXLOG(uint32 data_checksum_version)
 	checkPoint.newestCommitTsXid = InvalidTransactionId;
 	checkPoint.time = (pg_time_t) time(NULL);
 	checkPoint.oldestActiveXid = InvalidTransactionId;
-	checkPoint.dataChecksumState = data_checksum_version;
 
 	TransamVariables->nextXid = checkPoint.nextXid;
 	TransamVariables->nextOid = checkPoint.nextOid;
@@ -6620,50 +6246,6 @@ StartupXLOG(void)
 	pfree(endOfRecoveryInfo->recoveryStopReason);
 	pfree(endOfRecoveryInfo);
 
-	/*
-	 * If we reach this point with checksums in the state inprogress-on, it
-	 * means that data checksums were in the process of being enabled when the
-	 * cluster shut down. Since processing didn't finish, the operation will
-	 * have to be restarted from scratch since there is no capability to
-	 * continue where it was when the cluster shut down. Thus, revert the
-	 * state back to off, and inform the user with a warning message. Being
-	 * able to restart processing is a TODO, but it wouldn't be possible to
-	 * restart here since we cannot launch a dynamic background worker
-	 * directly from here (it has to be from a regular backend).
-	 */
-	if (XLogCtl->data_checksum_version == PG_DATA_CHECKSUM_INPROGRESS_ON)
-	{
-		XLogChecksums(PG_DATA_CHECKSUM_OFF);
-
-		SpinLockAcquire(&XLogCtl->info_lck);
-		XLogCtl->data_checksum_version = PG_DATA_CHECKSUM_OFF;
-		SetLocalDataChecksumState(XLogCtl->data_checksum_version);
-		SpinLockRelease(&XLogCtl->info_lck);
-
-		EmitAndWaitDataChecksumsBarrier(PG_DATA_CHECKSUM_OFF);
-		ereport(WARNING,
-				errmsg("enabling data checksums was interrupted"),
-				errhint("Data checksum processing must be manually restarted for checksums to be enabled."));
-	}
-
-	/*
-	 * If data checksums were being disabled when the cluster was shut down,
-	 * we know that we have a state where all backends have stopped validating
-	 * checksums and we can move to off instead of prompting the user to
-	 * perform any action.
-	 */
-	else if (XLogCtl->data_checksum_version == PG_DATA_CHECKSUM_INPROGRESS_OFF)
-	{
-		XLogChecksums(PG_DATA_CHECKSUM_OFF);
-
-		SpinLockAcquire(&XLogCtl->info_lck);
-		XLogCtl->data_checksum_version = PG_DATA_CHECKSUM_OFF;
-		SetLocalDataChecksumState(XLogCtl->data_checksum_version);
-		SpinLockRelease(&XLogCtl->info_lck);
-
-		EmitAndWaitDataChecksumsBarrier(PG_DATA_CHECKSUM_OFF);
-	}
-
 	/*
 	 * All done with end-of-recovery actions.
 	 *
@@ -6683,7 +6265,6 @@ StartupXLOG(void)
 	ControlFile->state = DB_IN_PRODUCTION;
 
 	SpinLockAcquire(&XLogCtl->info_lck);
-	ControlFile->data_checksum_version = XLogCtl->data_checksum_version;
 	XLogCtl->SharedRecoveryState = RECOVERY_STATE_DONE;
 	SpinLockRelease(&XLogCtl->info_lck);
 
@@ -6970,7 +6551,7 @@ GetRedoRecPtr(void)
 	XLogRecPtr	ptr;
 
 	/*
-	 * The possibly not up-to-date copy in XLogCtl is enough. Even if we
+	 * The possibly not up-to-date copy in XlogCtl is enough. Even if we
 	 * grabbed a WAL insertion lock to read the authoritative value in
 	 * Insert->RedoRecPtr, someone might update it just after we've released
 	 * the lock.
@@ -7548,14 +7129,6 @@ CreateCheckPoint(int flags)
 	checkPoint.fullPageWrites = Insert->fullPageWrites;
 	checkPoint.wal_level = wal_level;
 
-	/*
-	 * Get the current data_checksum_version value from xlogctl, valid at the
-	 * time of the checkpoint.
-	 */
-	SpinLockAcquire(&XLogCtl->info_lck);
-	checkPoint.dataChecksumState = XLogCtl->data_checksum_version;
-	SpinLockRelease(&XLogCtl->info_lck);
-
 	if (shutdown)
 	{
 		XLogRecPtr	curInsert = XLogBytePosToRecPtr(Insert->CurrBytePos);
@@ -7612,9 +7185,6 @@ CreateCheckPoint(int flags)
 
 		WALInsertLockAcquire();
 		redo_rec.wal_level = wal_level;
-		SpinLockAcquire(&XLogCtl->info_lck);
-		redo_rec.data_checksum_version = XLogCtl->data_checksum_version;
-		SpinLockRelease(&XLogCtl->info_lck);
 		WALInsertLockRelease();
 
 		/* Include WAL level in record for WAL summarizer's benefit. */
@@ -7967,12 +7537,6 @@ CreateEndOfRecoveryRecord(void)
 	LWLockAcquire(ControlFileLock, LW_EXCLUSIVE);
 	ControlFile->minRecoveryPoint = recptr;
 	ControlFile->minRecoveryPointTLI = xlrec.ThisTimeLineID;
-
-	/* start with the latest checksum version (as of the end of recovery) */
-	SpinLockAcquire(&XLogCtl->info_lck);
-	ControlFile->data_checksum_version = XLogCtl->data_checksum_version;
-	SpinLockRelease(&XLogCtl->info_lck);
-
 	UpdateControlFile();
 	LWLockRelease(ControlFileLock);
 
@@ -8314,10 +7878,6 @@ CreateRestartPoint(int flags)
 			if (flags & CHECKPOINT_IS_SHUTDOWN)
 				ControlFile->state = DB_SHUTDOWNED_IN_RECOVERY;
 		}
-
-		/* we shall start with the latest checksum version */
-		ControlFile->data_checksum_version = lastCheckPoint.dataChecksumState;
-
 		UpdateControlFile();
 	}
 	LWLockRelease(ControlFileLock);
@@ -8756,25 +8316,6 @@ XLogReportParameters(void)
 	}
 }
 
-/*
- * Log the new state of checksums
- */
-static void
-XLogChecksums(uint32 new_type)
-{
-	xl_checksum_state xlrec;
-	XLogRecPtr	recptr;
-
-	xlrec.new_checksum_state = new_type;
-
-	XLogBeginInsert();
-	XLogRegisterData((char *) &xlrec, sizeof(xl_checksum_state));
-
-	recptr = XLogInsert(RM_XLOG2_ID, XLOG2_CHECKSUMS);
-	pg_atomic_write_u64(&XLogCtl->lastChecksumChangeRecPtr, recptr);
-	XLogFlush(recptr);
-}
-
 /*
  * Update full_page_writes in shared memory, and write an
  * XLOG_FPW_CHANGE record if necessary.
@@ -8960,9 +8501,6 @@ xlog_redo(XLogReaderState *record)
 		/* ControlFile->checkPointCopy always tracks the latest ckpt XID */
 		LWLockAcquire(ControlFileLock, LW_EXCLUSIVE);
 		ControlFile->checkPointCopy.nextXid = checkPoint.nextXid;
-		ControlFile->data_checksum_version = checkPoint.dataChecksumState;
-
-		UpdateControlFile();
 		LWLockRelease(ControlFileLock);
 
 		/*
@@ -9199,20 +8737,7 @@ xlog_redo(XLogReaderState *record)
 	}
 	else if (info == XLOG_CHECKPOINT_REDO)
 	{
-		xl_checkpoint_redo redo_rec;
-		bool		new_state = false;
-
-		memcpy(&redo_rec, XLogRecGetData(record), sizeof(xl_checkpoint_redo));
-
-		SpinLockAcquire(&XLogCtl->info_lck);
-		XLogCtl->data_checksum_version = redo_rec.data_checksum_version;
-		SetLocalDataChecksumState(redo_rec.data_checksum_version);
-		if (redo_rec.data_checksum_version != ControlFile->data_checksum_version)
-			new_state = true;
-		SpinLockRelease(&XLogCtl->info_lck);
-
-		if (new_state)
-			EmitAndWaitDataChecksumsBarrier(redo_rec.data_checksum_version);
+		/* nothing to do here, just for informational purposes */
 	}
 	else if (info == XLOG_LOGICAL_DECODING_STATUS_CHANGE)
 	{
@@ -9265,64 +8790,6 @@ xlog_redo(XLogReaderState *record)
 	}
 }
 
-void
-xlog2_redo(XLogReaderState *record)
-{
-	uint8		info = XLogRecGetInfo(record) & ~XLR_INFO_MASK;
-
-	if (info == XLOG2_CHECKSUMS)
-	{
-		xl_checksum_state state;
-		XLogRecPtr	lsn = record->EndRecPtr;
-
-		memcpy(&state, XLogRecGetData(record), sizeof(xl_checksum_state));
-
-		/* advertise the location before the new state becomes visible */
-		pg_atomic_write_u64(&XLogCtl->lastChecksumChangeRecPtr, lsn);
-
-		SpinLockAcquire(&XLogCtl->info_lck);
-		XLogCtl->data_checksum_version = state.new_checksum_state;
-		SpinLockRelease(&XLogCtl->info_lck);
-
-		LWLockAcquire(ControlFileLock, LW_EXCLUSIVE);
-		ControlFile->data_checksum_version = state.new_checksum_state;
-
-		/*
-		 * Update minRecoveryPoint to ensure that if recovery is aborted, we
-		 * recover back up to this point before allowing hot standby again.
-		 * The new state is durable in pg_control while its location is only
-		 * tracked in shared memory; a standby becoming consistent below this
-		 * record would let base backups resume checksum verification with the
-		 * location unknown.  The local copies cannot be updated as long as
-		 * crash recovery is happening and we expect all the WAL to be
-		 * replayed.
-		 */
-		if (InArchiveRecovery)
-		{
-			LocalMinRecoveryPoint = ControlFile->minRecoveryPoint;
-			LocalMinRecoveryPointTLI = ControlFile->minRecoveryPointTLI;
-		}
-		if (XLogRecPtrIsValid(LocalMinRecoveryPoint) && LocalMinRecoveryPoint < lsn)
-		{
-			TimeLineID	replayTLI;
-
-			(void) GetCurrentReplayRecPtr(&replayTLI);
-			ControlFile->minRecoveryPoint = lsn;
-			ControlFile->minRecoveryPointTLI = replayTLI;
-		}
-
-		UpdateControlFile();
-		LWLockRelease(ControlFileLock);
-
-		/*
-		 * Block on a procsignalbarrier to await all processes having seen the
-		 * change to checksum status. Once the barrier has been passed we can
-		 * initiate the corresponding processing.
-		 */
-		EmitAndWaitDataChecksumsBarrier(state.new_checksum_state);
-	}
-}
-
 /*
  * Return the extra open flags used for opening a file, depending on the
  * value of the GUCs wal_sync_method, fsync and debug_io_direct.
diff --git a/src/backend/backup/basebackup.c b/src/backend/backup/basebackup.c
index 4dcb06942d1..8e26c4f8118 100644
--- a/src/backend/backup/basebackup.c
+++ b/src/backend/backup/basebackup.c
@@ -45,7 +45,6 @@
 #include "storage/reinit.h"
 #include "utils/builtins.h"
 #include "utils/guc.h"
-#include "utils/injection_point.h"
 #include "utils/ps_status.h"
 #include "utils/relcache.h"
 #include "utils/resowner.h"
@@ -108,7 +107,6 @@ static off_t read_file_data_into_buffer(bbsink *sink,
 										int *checksum_failures);
 static void push_to_sink(bbsink *sink, pg_checksum_context *checksum_ctx,
 						 size_t *bytes_done, void *data, size_t length);
-static bool backup_checksums_verifiable(XLogRecPtr start_lsn);
 static bool verify_page_checksum(Page page, XLogRecPtr start_lsn,
 								 BlockNumber blkno,
 								 uint16 *expected_checksum);
@@ -327,12 +325,6 @@ perform_base_backup(basebackup_options *opt, bbsink *sink,
 		/* notify basebackup sink about start of backup */
 		bbsink_begin_backup(sink, &state, SINK_BUFFER_LENGTH);
 
-		/*
-		 * Allow tests to hold the backup after the starting checkpoint but
-		 * before any file data is sent.
-		 */
-		INJECTION_POINT("basebackup-before-send-files", NULL);
-
 		/* Send off our tablespaces one by one */
 		foreach(lc, state.tablespaces)
 		{
@@ -1616,14 +1608,12 @@ sendFile(bbsink *sink, const char *readfilename, const char *tarfilename,
 	Assert((sink->bbs_buffer_length % BLCKSZ) == 0);
 
 	/*
-	 * Verify checksums unless the client requested otherwise, but only for
-	 * relation files, and only while checksums have been continuously enabled
-	 * since the checkpoint this backup started from.  Checksums can still be
-	 * disabled while the backup runs, thus we check at each point where we
-	 * could be validating a checksum.
+	 * If we weren't told not to verify checksums, and if checksums are
+	 * enabled for this cluster, and if this is a relation file, then verify
+	 * the checksum.
 	 */
-	if (!noverify_checksums && RelFileNumberIsValid(relfilenumber) &&
-		backup_checksums_verifiable(sink->bbs_state->startptr))
+	if (!noverify_checksums && DataChecksumsEnabled() &&
+		RelFileNumberIsValid(relfilenumber))
 		verify_checksum = true;
 
 	/*
@@ -1756,9 +1746,7 @@ sendFile(bbsink *sink, const char *readfilename, const char *tarfilename,
 		 * If the amount of data we were able to read was not a multiple of
 		 * BLCKSZ, we cannot verify checksums, which are block-level.
 		 */
-		if (verify_checksum &&
-			backup_checksums_verifiable(sink->bbs_state->startptr) &&
-			(cnt % BLCKSZ != 0))
+		if (verify_checksum && (cnt % BLCKSZ != 0))
 		{
 			ereport(WARNING,
 					(errmsg("could not verify checksum in file \"%s\", block "
@@ -1853,10 +1841,9 @@ sendFile(bbsink *sink, const char *readfilename, const char *tarfilename,
  * 'blkno' is the block number of the first page in the bbsink's buffer
  * relative to the start of the relation.
  *
- * 'verify_checksum' determines if the user has asked to verify checksums, but
- * since data checksums can be disabled, or become disabled, we need to check
- * state before verifying individual pages.  If we do this, we'll update
- * *checksum_failures and issue warnings as appropriate.
+ * 'verify_checksum' indicates whether we should try to verify checksums
+ * for the blocks we read. If we do this, we'll update *checksum_failures
+ * and issue warnings as appropriate.
  */
 static off_t
 read_file_data_into_buffer(bbsink *sink, const char *readfilename, int fd,
@@ -1882,13 +1869,6 @@ read_file_data_into_buffer(bbsink *sink, const char *readfilename, int fd,
 		int			reread_cnt;
 		uint16		expected_checksum;
 
-		/*
-		 * The data checksum state can change at any point, so we need to
-		 * re-check before each page.
-		 */
-		if (!backup_checksums_verifiable(sink->bbs_state->startptr))
-			return cnt;
-
 		page = sink->bbs_buffer + BLCKSZ * i;
 
 		/* If the page is OK, go on to the next one. */
@@ -1911,12 +1891,7 @@ read_file_data_into_buffer(bbsink *sink, const char *readfilename, int fd,
 		 * allows us to wait until we can be certain that no write to the
 		 * block is in progress. Since we don't have any such thing right now,
 		 * we just do this and hope for the best.
-		 *
-		 * The data checksum state may also have changed concurrently so check
-		 * again.
 		 */
-		if (!backup_checksums_verifiable(sink->bbs_state->startptr))
-			return cnt;
 		reread_cnt =
 			basebackup_read_file(fd, sink->bbs_buffer + BLCKSZ * i,
 								 BLCKSZ, offset + BLCKSZ * i,
@@ -2006,27 +1981,6 @@ push_to_sink(bbsink *sink, pg_checksum_context *checksum_ctx,
 	}
 }
 
-/*
- * Check whether data checksums can be verified for a backup started at
- * start_lsn.
- *
- * Checksums are verified only while they have been continuously enabled
- * since the checkpoint the backup started from: the state must be "on" and
- * the last state change must predate the backup start.  Such a checkpoint
- * guarantees that every page flushed before it has a checksum written.  Any
- * later state change ends verification for the rest of the backup: pages
- * written while checksums were off can lack checksums yet keep LSNs older
- * than the backup start, and re-enabling completes before the rewritten
- * pages are flushed, so observing the "on" state again is not enough to
- * resume.
- */
-static bool
-backup_checksums_verifiable(XLogRecPtr start_lsn)
-{
-	return DataChecksumsNeedVerify() &&
-		GetLastChecksumChangeRecPtr() <= start_lsn;
-}
-
 /*
  * Try to verify the checksum for the provided page, if it seems appropriate
  * to do so.
@@ -2052,35 +2006,9 @@ verify_page_checksum(Page page, XLogRecPtr start_lsn, BlockNumber blkno,
 	if (PageIsNew(page) || PageGetLSN(page) >= start_lsn)
 		return true;
 
-	if (!backup_checksums_verifiable(start_lsn))
-		return true;
-
 	/* Perform the actual checksum calculation. */
 	checksum = pg_checksum_page(page, blkno);
 
-#ifdef USE_INJECTION_POINTS
-	{
-		/*
-		 * Make it possible to test checksum verification failure without
-		 * having to destroy data on disk.  There is cap on how many times we
-		 * want to cause verification failure to make tests more interesting
-		 * and less log intensive.  This makes it easy to test pg_basebackup
-		 * with the command_checks_all test function.
-		 */
-		static int	hit = 0;
-
-		if (IS_INJECTION_POINT_ATTACHED("basebackup-fail-checksum-verification"))
-		{
-			if (hit++ < 5)
-			{
-				checksum = 0;
-				INJECTION_POINT_CACHED("basebackup-fail-checksum-verification",
-									   NULL);
-			}
-		}
-	}
-#endif
-
 	/* See whether it matches the value from the page. */
 	phdr = (PageHeader) page;
 	if (phdr->pd_checksum == checksum)
